//#include <gtk/gtk.h>

#ifndef __UI_H
#define __UI_H

#define j_box_pack(b,w,x,y,z) \
        gtk_box_pack_start(GTK_BOX(b),w,x,y,z)

typedef struct {
   int type;
   char *conf;
   int key;
   GList *sensitive;
} WidgetProperty;

typedef struct {
   GtkWidget *window;
   GtkWidget *notebook;
   GtkWidget *appbar;
   GtkProgress *progress;
   GtkStyle *normal;
   GtkStyle *highlight;
   int appbar_timeout;
} GnapsterMain;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *entry;
   GtkWidget *not_label;
   GtkWidget *not_entry;
   GtkWidget *gtk_entry;
   GtkWidget *gtk_not_entry;
   GtkWidget *search_btn;
   GtkWidget *list_btn;
   GtkWidget *line_speed_switch;
   GtkWidget *line_speed;
   GtkWidget *line_speed_cmp;
   GtkWidget *bitrate_switch;
   GtkWidget *bitrate;
   GtkWidget *bitrate_cmp;
   GtkWidget *local_only;
   GtkWidget *media;
   GtkWidget *clist;
   GtkWidget *scroller;
} SearchTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *entry;
   GtkWidget *list_btn;
   GtkWidget *scroller;
   GtkWidget *ctree;
} BrowseTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *max_downloads_switch;
   GtkWidget *max_downloads;
   GtkWidget *max_peruser_downloads_switch;
   GtkWidget *max_peruser_downloads;
   GtkWidget *clist;
   GtkWidget *queue_clist;
   GtkWidget *start_queue;
   GtkWidget *stop_queue;
   GtkWidget *queue_label;
   GtkWidget *scroller;
} DownloadTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *max_uploads_switch;
   GtkWidget *max_uploads;
   GtkWidget *max_peruser_uploads_switch;
   GtkWidget *max_peruser_uploads;
   GtkWidget *clist;
   GtkWidget *scroller;
} UploadTab;

typedef struct {
   GtkWidget *main_vbox;
   GtkWidget *notebook;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
   GtkWidget *entry;
   GList *channel_list;
   GtkWidget *links_map;
} ConsoleTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
   GtkWidget *scroller2;
   GtkWidget *hide_list;
   GtkWidget *clist;
   char *channel;
} ChannelTab;

typedef struct {
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *text;
   GtkWidget *scroller;
} MOTDTab;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *new_user;
   GtkWidget *nap_port;
   GtkWidget *user_entry;
   GtkWidget *pass_entry;
   GtkWidget *connection;
   GtkWidget *download_dir;
   GtkWidget *upload_dir;
   GtkWidget *build_list;
   GtkWidget *update_list;
   GtkWidget *autoquery;
   GtkWidget *name_fix;
   GtkWidget *hide_users;
   GtkWidget *theme_colors;
   GtkWidget *auto_rm;
   GtkWidget *opennap_server;
   GtkWidget *server_entry;
   GtkWidget *auto_start_queue;
   GtkWidget *reject_ul;
   GtkWidget *firewall;
   GtkWidget *aj_entry;
   GtkWidget *aj_add;
   GtkWidget *aj_remove;
   GtkWidget *aj_clist;
   GtkWidget *font_entry;
   GtkWidget *font_browse;
   int calling;
} PropDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   int pipe_input;
   int cpid;
} BuildDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *clist;
   GtkWidget *add;
   GtkWidget *edit;
   GtkWidget *delete;
   GtkWidget *refresh;
   GtkWidget *scroller;
} BrowseDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
} RefreshDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *server;
   GtkWidget *port;
   GtkWidget *desc;
   GtkWidget *network;
} EditDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *server;
   GtkWidget *port;
   GtkWidget *desc;
   GtkWidget *network;
} AddDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *scroller;
   GtkWidget *clist;
} ListChanDlg;

typedef struct {
   GtkWidget *window;
   GtkWidget *vbox;
   GtkWidget *hbox;
   GtkWidget *label;
   GtkWidget *scroller;
   GtkWidget *clist;
} ResumeDlg;

GtkWidget *j_line_new(GtkWidget *, int, int);
GtkWidget *j_combo_new(int, ...);

GtkWidget *create_gnapster_tab(char *, char *);
void create_gnapster_main();
void create_search_tab();
void create_browse_tab();
void browse_tab_add(Search *);
void create_download_tab();
void create_upload_tab();
void create_console_tab();
void append_console_tab(char *, int);
int remove_console_tab(int);
void create_motd_tab();
void create_prop_dlg(void *, void *, void *, void *, int *);
void create_build_dlg();
void create_browse_dlg();
void create_add_dlg();
void create_edit_dlg();
void create_list_chan_dlg();
void create_resume_dlg();
void create_refresh_dlg();

#endif /* __UI_H */
